NumText:
;INPUT hl = number

	push bc
	push af
		ld b,1
		
		push hl
			ld c,1
			ld de,10000
			or a
			sbc hl,de ; cp
			jr nc,{+1@}
			add hl,de
			inc c
			ld de,1000
			or a
			sbc hl,de ; cp
			jr nc,{+1@}
			add hl,de
			inc c
			ld de,100
			or a
			sbc hl,de ; cp
			jr nc,{+1@}
			add hl,de
			inc c
			ld de,10
			or a
			sbc hl,de ; cp
			jr nc,{+1@}
			add hl,de
			inc c
		@:
			ld hl,textBuffer
			ld (textCounter),hl
		pop hl
		
		ld	de,-10000
		call	Num1
		ld	de,-1000
		call	Num1
		ld	de,-100
		call	Num1
		ld	e,-10
		call	Num1
		ld	e,-1
		call	Num1
		
		ld hl,(textCounter)
		ld (hl),0
		ld hl,textBuffer
	pop af
	pop bc
	call Text
	ret
Num1:
	ld	a,$01-1
Num2:	inc	a
	add	hl,de
	jr	c,Num2
	sbc	hl,de
	dec c
	ret nz
	inc c
	push hl
	ld hl,(textCounter)
	ld (hl),a
	inc hl
	ld (textCounter),hl
	pop hl
	ret

Text:
;INPUT: b=xpos
;;c=ypos
;;hl = text
;;a = (0 - big, 1 - small), char-by-char(2 - big, 3 - small)
;Destroys: de,ix,iy
	ld de,Chars ; add offset
	push af
		and %00000010
		ld (tmp3),a
		ld a,7
		ld (tmp1),a
		ld a,6
		ld (tmp2),a
	pop af
	push bc
	and %00000001
	cp 0
	jr z,_Text_Loop ; we use the big font!
		ld de,SmallChars ; time to use the small font
		ld a,5
		ld (tmp1),a
		ld a,4
		ld (tmp2),a
_Text_Loop:
	ld a,(tmp3)
	cp 2
	jr nz,_Text_Skip_Key
		in a,(1)
		cp $FF
		jr c,_Text_Skip_Key
		ld a,4
		bcall(_Sleep)
	_Text_Skip_Key:
	ld a,(hl)
	cp 0
	jr z,_Text_end
	cp $fe
	jr z,_Text_end
	cp $fd
	jr z,_Text_end
	push hl
	push bc
		dec a ; sprites start one earlier
		
		
		
		push de
			push bc
				cp $fe ; we subtracted one
				jr z,_Text_Loop_Line_Break
				
				ld h,0 ; a into hl and times tmp1
				ld l,a
				ld a,(tmp1)
				ld b,a
				bcall(_Multiply)
			pop bc
			
			
			
			ld a,b
			push af
				ld a,(tmp1)
				ld b,a
			pop af
		pop de
		
		add hl,de
		push hl ; ld hl,ix
		pop ix
		
		push de
			ld h,c
			push af
			push hl
			push bc
			push ix
			ld de,PlotSScreen
			bcall(_PutSpriteXOR)
			pop ix
			pop bc
			pop hl
			pop af
			ld de,AppBackUpScreen
			bcall(_PutSpriteXOR)
		pop de
	pop bc
	pop hl
	inc hl
	
	ld a,(tmp2)

	add a,b
	ld b,a
	jr _Text_Loop
_Text_Loop_Line_Break:
	
	pop bc
	pop de
	pop bc
	pop hl
	
	pop bc ; get original positions
	ld a,8
	add a,c
	ld c,a
	push bc
	
	inc hl
	jr _Text_Loop
_Text_end
	pop bc
	inc hl
	ret
